# www.Tricks12345.com, Template last update July 17, 2018
import sqlite3
import openpyxl
from flask import Flask, render_template,url_for, request,redirect
import matplotlib.pyplot as plt
from selenium import webdriver
from selenium.webdriver.common.action_chains import ActionChains
import time
app = Flask(__name__)
@app.route('/')  
def index():
       driver = webdriver.Chrome()
       driver.maximize_window()
       totalrows = [];Headers = []; bodydata = []; rowsdata = [] 
       url = 'https://www.nseindia.com'
       driver.get(url)
       time.sleep(3)
       menu = driver.find_element_by_css_selector('#main_livemkt')
       submenu =  driver.find_element_by_css_selector('#main_livemkt #main_livewth_stkwth')
       ActionChains(driver).move_to_element(menu).click(submenu).perform()
       time.sleep(3)
       driver.current_window_handle          
       totalrows = driver.find_element_by_id('dataTable').find_elements_by_tag_name('tr')
       rowcount = len(driver.find_element_by_id('dataTable').find_elements_by_tag_name('tr'))        
       for row in  totalrows:
             rowdata = []
             for c,col in enumerate(row.find_elements_by_tag_name('td') or row.find_elements_by_tag_name('th')):
                if c  == 1 or c  == 2 or c  == 13 or c  == 15:
                        continue
                if col.tag_name  == 'th':                     
                    Headers.append(col.text)
                if col.tag_name  == 'td':
                     if c >= 3:
                          z = col.text.replace(',','')
                          rowdata.append(float(z))
                     else: rowdata.append(col.text)                    
             bodydata.append(tuple(rowdata))
       rowsdata = bodydata[2:]
       colscount = len(Headers)
       driver.close()
       time.sleep(2)
       conn = sqlite3.connect("NSE Data.db")
       cur =  conn.cursor()
       conn.execute('CREATE TABLE  IF NOT EXISTS  companies \
                 (Symbol TEXT, Open int, High int, \
                 Low int, LTP int, Chng int, Chngpercent int,Volume int, \
                 Turnover int, wH int, Low52w int, chng365 int,d30 int )')              
       conn.commit()
       for i in range(len(rowsdata)):
                    Symbol = rowsdata[i][0]
                    Open = rowsdata[i][1]
                    High = rowsdata[i][2]
                    Low = rowsdata[i][3]
                    LTP =  rowsdata[i][4]
                    Chng = rowsdata[i][5]
                    Chngpercent = rowsdata[i][6]
                    Volume = rowsdata[i][7]
                    Turnover = rowsdata[i][8]
                    wH = rowsdata[i][9]
                    Low52w = rowsdata[i][10]
                    chng365 = rowsdata[i][11]
                    d30 = rowsdata[i][12]
                    cur.execute("INSERT INTO companies (Symbol,Open,High,Low,LTP,Chng,Chngpercent,Volume, Turnover,wH,Low52w,chng365, d30)  VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)",  (Symbol,Open,High,Low,LTP,Chng,Chngpercent,Volume, Turnover,wH,Low52w,chng365, d30))
                    conn.commit()
       #========================First Query=========================         
       # Retrieve all records ===========================================                    
       cur.execute("select * from companies")
       output =  cur.fetchall()
       Headers = Headers
       ColsCount = len(Headers)
       rowscount = len(output)
       #========================Second Query=========================         
       # Open Price between 1000 to 3000 top 5 companies =========================
       cur.execute("select  Symbol, Open from companies where Open between  1000 and 3000 order by Open Desc Limit 5")
       secondrows =  cur.fetchall(); SecondHeader = ['Symbol', 'Open']; xdata = []; ydata = []        
       colrs = ['k','g','r','b', 'y']
       exp  = (0.1,0.1,0.1,0.1,0.1)
       for i in range(len(secondrows)):
          xdata.append(secondrows[i][0])
          ydata.append(secondrows[i][1])
       fig= plt.figure(figsize=(5,4))
       plt.pie(ydata, labels=xdata, colors=colrs, explode = exp)
       plt.title('Open Price 1000 to 3000 top 5 companies')
       plt.legend(loc = 'upper right')
       plt.savefig('./static/OpenPrice1000to3000top5.png')
       plt.close()
       #==============================Third Query======================
       # =======Top 5 companies from third based on High=========================
       cur.execute("Select Symbol, High from companies Order by High Desc  Limit 5 OFFSET 2")
       Thirdrows =  cur.fetchall(); ThirdHeader = ['Symbol', 'High']; xdata = []; ydata = []
       for i in range(len(Thirdrows)):
          xdata.append(Thirdrows[i][0])
          ydata.append(Thirdrows[i][1])
       maxdata = max(ydata); maxindex = ydata.index(maxdata)
       fig= plt.figure(figsize=(7,4))
       bars = plt.bar(xdata, ydata, color = 'r', width = 0.5, label = 'High Price')
       bars[maxindex].set_facecolor('blue')
       plt.title('Max High price bar colored with Blue')
       plt.legend()
       plt.savefig('./static/NSEDataHighprice.png')
       plt.close()
       #====================Fourth Query===============================
       #Top 5 companies having LTP greater than Averge LTP========================
       cur.execute('select  max(LTP), min(LTP), round(avg(LTP),2),Count(LTP),Count(*)  from companies')
       stat = cur.fetchall()
       cur.execute('select Symbol, LTP  from companies where LTP > {avgprice} Order by LTP desc Limit 5 '.format(avgprice = stat[0][2]))
       Fourthrows = cur.fetchall();xdata = []; ydata = [];FourthHeader = ['Symbol', 'LTP']       
       for i in range(len(Fourthrows)):
          xdata.append(Fourthrows[i][0])
          ydata.append(Fourthrows[i][1])
       fig= plt.figure(figsize=(7,4))  
       plt.plot(xdata,ydata, label = 'LTP > Avg LTP',
             color = 'red', linewidth = 5, marker = 'o', markerfacecolor = 'blue', markersize = 11)
       plt.xlabel('Symbols')
       plt.ylabel('LTP')
       plt.title('5 Companies having Open price > 1000 from the Top')
       plt.legend(loc = 'upper left')
       plt.savefig('./static/LTPGreaterThanAVG.png')
       plt.close()
       #====================Fifth Query===============================
       #Low price > 1000 ===================First 5 companies=================
       cur.execute('select Symbol, Low  from companies where Low > 1000   Order by  Low desc Limit 5 ')
       Fifthrows = cur.fetchall();xdata = []; ydata = [];FifthHeader = ['Symbol','Low']       
       for i in range(len(Fifthrows)):
          xdata.append(Fifthrows[i][0])
          ydata.append(Fifthrows[i][1])
       fig= plt.figure(figsize=(6,4))  
       mindata = min(ydata); minindex = ydata.index(mindata)
       fig= plt.figure(figsize=(7,4))
       bars = plt.bar(xdata, ydata, color = 'r', width = 0.5, label = 'Low')
       bars[minindex].set_facecolor('blue')
       plt.title('Min Low price bar colored with Blue')
       plt.legend()
       plt.savefig('./static/NSEDataLowprice.png')
       plt.close() 
       #===================Close the connections===========================
       cur.close()
       conn.close()
       return render_template("Consolidation_of_SQL_Queries.html", \
                              Totalrows = output,rowscount = rowscount, Headers = Headers, ColsCount = ColsCount, \
                              secondrows = secondrows,  Secondrowslen  = len(secondrows), SecondHeader = SecondHeader, SecondHeaderlen =2, \
                              Thirdrows = Thirdrows,  Thirdrowslen  = len(Thirdrows), ThirdHeader = ThirdHeader, ThirdHeaderlen =2, \
                              Fourthrows = Fourthrows,  Fourthrowslen  = len(Fourthrows), FourthHeader = FourthHeader, FourthHeaderlen =2, stat = stat, \
                              Fifthrows = Fifthrows,  Fifthrowslen  = len(Fifthrows), FifthHeader = FifthHeader, FifthHeaderlen =2)
#http://localhost:4500
app.run(host='localhost', port=4500, debug=True)  
